<?php
/**
*
* @package dm partners
* @version $Id: dm_partners.php 22 2010-08-08 14:52:46Z femu $
* @copyright (c) 2008, 2010 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' .$phpEx);
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_partners');

$mode = request_var('mode', 'view', 'add');

if ( !$auth->acl_get('u_dm_partners_view') )
{
	$message = $user->lang['NOT_AUTHORISED'];
	trigger_error($message);
}

if ( $mode == 'add' )
{
	if (($user->data['is_bot']) || ($user->data['user_id'] == ANONYMOUS))
	{
		redirect(append_sid("{$phpbb_root_path}ucp.$phpEx?mode=login"));
	}

	if ( isset($_POST['submit']) )
	{
		$back_link = sprintf($user->lang['DMP_ADD_BACK_LINK'], "<a href=\"" . append_sid("dm_partners.$phpEx?mode=add") . "\">", "</a>");
		$lang_mode = $user->lang['DMP_TITLE_ADD'];
		$action = (!isset($_GET['action'])) ? '' : $_GET['action'];
		$action = ((isset($_POST['submit']) && !$_POST['id']) ? 'add' : $action );
		$id = request_var('id', 0);
		$site = request_var('site', '', true);
		$url = request_var('url', '');
		$creator_id = $user->data['user_id'];

		//Settings
		$text = utf8_normalize_nfc(request_var('text', '', true));
		$uid = $bitfield = $options = '';
		$allow_bbcode = $allow_urls = $allow_smilies = true;
		generate_text_for_storage($text, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

		//Make SQL Array
		$sql_ary = array(
			'title'				=> $site,
			'text'              => $text,
			'bbcode_uid'        => $uid,
			'bbcode_bitfield'   => $bitfield,
			'enable_bbcode'		=> $allow_bbcode,
			'enable_smilies'	=> $allow_smilies,
			'enable_magic_url'	=> $allow_urls,
			'enable_count'		=> request_var('click_set', 1),
			'url'				=> $url,
			'image_url'			=> request_var('image', ''),
			'counter'			=> request_var('clicks', 1),
			'activ'				=> request_var('activ', 0),
			'creator_id'		=> $creator_id,
		);

		$template->assign_vars(array(
			'S_POST_ACTION'			=> append_sid("{$phpbb_root_path}dm_partners.$phpEx", 'mode=add'),
			)
		);

		if ($site == '' || $url == '')
		{
			if ($site == '' && $url == '')
			{
				trigger_error($user->lang['DMP_NEED_DATA']. $back_link);
			}
			elseif ($site == '')
			{
				trigger_error($user->lang['DMP_NEED_SITE'] . $back_link);
			}
			elseif ($url == '')
			{
				trigger_error($user->lang['DMP_NEED_URL'] . $back_link);
			}
		}
		else
		{
			$db->sql_query('INSERT INTO ' . DM_PARTNERS_TABLE .' ' . $db->sql_build_array('INSERT', $sql_ary));
			trigger_error($user->lang['DMP_ADDED'] . sprintf($user->lang['DMP_BACK_LINK'], "<a href=\"" . append_sid("dm_partners.$phpEx") . "\">", "</a>"));
		}
	}
}

switch($mode)
{
	case 'redirect':

		$id = request_var('id', 0);

		$result = $db->sql_query('SELECT url FROM ' . DM_PARTNERS_TABLE . ' WHERE id = ' . (int) $id);
		$row = $db->sql_fetchrow($result);
		$db->sql_query('UPDATE ' . DM_PARTNERS_TABLE . ' SET counter = counter + 1 WHERE id = ' . (int) $id);

		header("Status: 301 Permanently Moved");
		header("Location: {$row['url']}");
		exit;
	break;

	case 'view':
		//Catch data from DB but only activ partners
		$sql_array = array(
			'SELECT'    => '*',
			'FROM'      => array(
				DM_PARTNERS_TABLE => 'p',
			),
			'WHERE'		=> 'activ <> 0',
			'ORDER_BY'	=> 'title ASC',
		);
		$sql = $db->sql_build_query('SELECT', $sql_array);
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$allow_bbcode = $row['enable_bbcode'];
			$allow_smilies = $row['enable_smilies'];
			$allow_urls = $row['enable_magic_url'];
			$option = (($allow_bbcode) ? OPTION_FLAG_BBCODE : 0) + (($allow_smilies) ? OPTION_FLAG_SMILIES : 0) + (($allow_urls) ? OPTION_FLAG_LINKS : 0);

			$image = array();
			if ($row['text'] == '')
			{
				$row['text'] = $user->lang['DMP_EMPTY_TEXT'];
			}

			$template->assign_block_vars('partners', array(
				'S_IMAGE'	=> ($row['image_url'] !== '') ? true : false,
				'S_COUNT'	=> ($row['enable_count'] == 1) ? true : false,
				'IMAGE'		=> $row['image_url'],
				'URL'		=> ($row['enable_count'] == 1) ? append_sid("{$phpbb_root_path}dm_partners.".$phpEx, 'mode=redirect&amp;id='.$row['id']) : $row['url'] ,
				'TITLE'		=> censor_text($row['title']),
				'TEXT'		=> generate_text_for_display($row['text'], $row['bbcode_uid'], $row['bbcode_bitfield'], $option),
				'COUNTER'	=> ($row['counter'] == 1) ? $row['counter'].$user->lang['DMP_COUNT'] : number_format($row['counter'], 0, '.', '.').$user->lang['DMP_COUNTS'],
				)
			);
		}

		if (!$row)
		{
			$template->assign_vars(array(
				'NO_ENTRY'	=> sprintf($user->lang['DMP_NO_ENTRY'], $config['sitename']),
				)
			);
		}

	$db->sql_freeresult($result);

	break;
}

$template->assign_vars(array(
	'ADD_IMG'		=> $user->img('button_partners', 'DMP_ADD'),
	'U_ADD_IMG'		=> append_sid("{$phpbb_root_path}dm_partners.$phpEx", 'mode=add'),
	'S_ALLOW_ADD'	=> $auth->acl_get('u_dm_partners_add'),
	'S_ALLOW_VIEW'	=> ($auth->acl_get('u_dm_partners_view')) ? true : false,
	)
);

page_header($user->lang['PARTNERS']);

$template->set_filenames(array(
	'body' => ($mode == 'add') ? 'dm_partners_add_body.html' : 'dm_partners_body.html')
);

page_footer();

?>